#include <avr/io.h>
#include <stdint.h>
#include <avr/interrupt.h>

#include "USI_TWI_SLAVE.h"

unsigned char Buffer[4];

union {
    float *f32;
    unsigned char *c;
  } stromwert;

#define ADC_activate						ADCSRA|=(1<<ADEN)
#define ADC_prescaler(Wert)					ADCSRA|=Wert;
#define ADC_channel(Wert)					ADMUX|=Wert
#define ADC_Vreference(Wert)				ADMUX|=(Wert<<REFS0)
#define ADC_conversion						ADCSRA |= (1<<ADSC)							
#define ADC_busyflag						(ADCSRA & (1<<ADSC))
#define ADC_deactivate						ADCSRA &= ~(1<<ADEN)

unsigned int read_adc()
{
	unsigned int adcwert=0, return_adc=0;
	
	ADC_activate;
	ADC_prescaler(6);
	ADC_channel(2);
	ADC_Vreference(0);

	ADC_conversion;			//Dummy Read-out ohne den ADC danach zu deaktivieren
	while(ADC_busyflag);
	adcwert = ADCL;
	adcwert += (ADCH<<8);
	adcwert=0;

	for(unsigned char i=0;i<=5;i++)
	{
		ADC_conversion;			//Tatschlicher Readout mit Mittelwertmessung
		while(ADC_busyflag);
		adcwert = ADCL;
		adcwert += (ADCH<<8);
		return_adc+=adcwert;	
	}
	
	ADC_deactivate;

	return_adc/=5;

	return return_adc;
}


int main()
{
	
	USI_TWI_Slave_Initialise();

	sei();

	
	for(;;)
	{
 		if(RecievedAddress&0x01)
		{
			float *stromwert.f32=(read_adc()-512)/23.1424;
			//ftor(stromwert,Buffer);
			USI_TWI_Slave_WriteBytes(stromwert.c,4);
			RecievedAddress=0;
		}

		asm volatile("nop");
	}
	return 0;
}
