void USI_TWI_Slave_Initialise();
void USI_TWI_Slave_WriteBytes(unsigned char *msg, unsigned char msgSize);
void USI_TWI_Slave_ReadBytes(unsigned char *msg, unsigned char msgSize);

unsigned char RecievedAddress;

#define TRUE                1
#define FALSE               0


#if	defined (__AVR_ATmega169__)| defined(__AT90Mega169__) | \
	defined(__AT90Mega165__) | defined(__ATmega165__) 	| \
    defined(__ATmega325__) | defined(__ATmega3250__) | \
    defined(__ATmega645__) | defined(__ATmega6450__) | \
    defined(__ATmega329__) | defined(__ATmega3290__) | \
    defined(__ATmega649__) | defined(__ATmega6490__)

	#define DDR_USI             DDRE
	#define PORT_USI            PORTE
	#define PIN_USI             PINE
	#define PORT_USI_SDA        PORTE5
	#define PORT_USI_SCL        PORTE4
	#define PIN_USI_SDA         PINE5
	#define PIN_USI_SCL         PINE4

#elif	defined (__AVR_ATtiny25__)| defined(__ATtiny45__) | defined(__ATtiny85__) | \
		defined(__AT90Tiny26__) | defined(__ATtiny26__)
	#define DDR_USI             DDRB
	#define PORT_USI            PORTB
	#define PIN_USI             PINB
	#define PORT_USI_SDA        PORTB0
	#define PORT_USI_SCL        PORTB2
	#define PIN_USI_SDA         PINB0
	#define PIN_USI_SCL         PINB2


#elif defined (__AVR_ATtiny2313__)|(__AT90Tiny2313__) 
	#define DDR_USI             DDRB
	#define PORT_USI            PORTB
	#define PIN_USI             PINB
	#define PORT_USI_SDA        PB5
	#define PORT_USI_SCL        PB7
	#define PIN_USI_SDA         PINB5
	#define PIN_USI_SCL         PINB7

#elif defined (__AVR_ATtiny25__)
	#define DDR_USI             DDRB
	#define PORT_USI            PORTB
	#define PIN_USI             PINB
	#define PORT_USI_SDA        PORTB0
	#define PORT_USI_SCL        PORTB2
	#define PIN_USI_SDA         PINB0
	#define PIN_USI_SCL         PINB2

#else
#warning "device type not defined"
#endif

#define SET_USI_TO_SEND_ACK()														\
{                             														\
        USIDR    =  0x00;  															\
        DDR_USI |=  (1<<PORT_USI_SDA);												\
        USISR    =  (0<<USISIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|(0x0E<<USICNT0);	\
}

#define SET_USI_TO_SEND_NACK()														\
{                             														\
        USIDR    =  0xFF;  															\
        DDR_USI |=  (1<<PORT_USI_SDA);												\
        USISR    =  (0<<USISIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|(0x0E<<USICNT0);	\
}

#define SET_USI_TO_READ_ACK()														\
{																					\
        DDR_USI &=  ~(1<<PORT_USI_SDA);												\
        USIDR    =  0;																\
        USISR    =  (0<<USISIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|(0x0E<<USICNT0);	\
}

#define SET_USI_TO_SEND_DATA()														\
{																					\
    DDR_USI |=  (1<<PORT_USI_SDA);               									\
    USISR    =  (0<<USISIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)| 						\
                (0x0<<USICNT0);														\
}

#define SET_USI_TO_READ_DATA()														\
{																					\
    DDR_USI &= ~(1<<PORT_USI_SDA); 													\
    USISR    =  (0<<USISIF)|(1<<USIOIF)|(1<<USIPF)|(1<<USIDC)|			\
                (0x0<<USICNT0);                         							\
}

